<!DOCTYPE html>
<html lang="en">
<head>
    <title>Order Detail</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- font -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

    <!-- Bootstrap -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()" style="background-color: oldlace">
    <div class="container mt-3 p-3" style="background-color: #f0daa1">
        <div class="row mt-2 mb-5">
            <div class="col-12 text-center">
                <h3><b class="border-bottom">ORDER DETAIL</b></h3>
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Mã đơn</label>
            <div class="col-4">
                <input id="input-ma-don" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Kích cỡ</label>
            <div class="col-4">
                <input id="input-kich-co" class="form-control">
            </div>
            <label class="col-2 col-form-label">Đường kính</label>
            <div class="col-4">
                <input id="input-duong-kinh" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Sườn</label>
            <div class="col-4">
                <input id="input-suon" class="form-control">
            </div>
            <label class="col-2 col-form-label">Salad</label>
            <div class="col-4">
                <input id="input-salad" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Loại Pizza</label>
            <div class="col-4">
                <input id="input-loai-pizza" class="form-control">
            </div>
            <label class="col-2 col-form-label">Voucher</label>
            <div class="col-4">
                <input id="input-voucher" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Thành tiền</label>
            <div class="col-4">
                <input id="input-thanh-tien" class="form-control">
            </div>
            <label class="col-2 col-form-label">Giảm giá</label>
            <div class="col-4">
                <input id="input-giam-gia" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Nước uống</label>
            <div class="col-4">
                <input id="input-drink" class="form-control">
            </div>
            <label class="col-2 col-form-label">Số lượng nước</label>
            <div class="col-4">
                <input id="input-drink-number" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Họ và tên</label>
            <div class="col-4">
                <input id="input-fullname" class="form-control">
            </div>
            <label class="col-2 col-form-label">Email</label>
            <div class="col-4">
                <input id="input-email" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Điện thoại</label>
            <div class="col-4">
                <input id="input-phone" class="form-control">
            </div>
            <label class="col-2 col-form-label">Địa chỉ</label>
            <div class="col-4">
                <input id="input-address" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Lời nhắn</label>
            <div class="col-4">
                <input id="input-message" class="form-control">
            </div>
            <label class="col-2 col-form-label">Trạng thái</label>
            <div class="col-4">
                <input id="input-status" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-2 col-form-label">Ngày tạo</label>
            <div class="col-4">
                <input id="input-day-create" class="form-control">
            </div>
            <label class="col-2 col-form-label">Ngày cập nhật</label>
            <div class="col-4">
                <input id="input-day-modify" class="form-control">
            </div>
        </div>
        <hr>
        <div class="row">
            <div class="col-12 text-center">
                <button class="btn btn-danger" onclick="onBtnCancelClick()">Cancel Order</button>
                <button class="btn btn-success" onclick="onBtnConfirmClick()">Confirm Order</button>
            </div>
        </div>
        <div class="row">
            <div class="col-12 text-center">
                <a href="orderList.html" class="btn btn-link">Back</a>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    var gOrderId = "";
    var gOrderCode = "";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiển load trang/F5
    function onPageLoading() {
        // B1: Thu thập dữ liệu
        let vUrl = new URL(window.location.href);
        gOrderId = vUrl.searchParams.get("id");
        gOrderCode = vUrl.searchParams.get("orderCode");
        // B2: Validate dữ liệu
        let vHaveCodeAndId = checkQueryString(gOrderCode, gOrderId);
        if (vHaveCodeAndId) {
            // B3: Gọi API lấy thông tin đơn hàng bằng order code
            let vXmlHttpOrderDetail = new XMLHttpRequest();
            callApiOrderDetail(vXmlHttpOrderDetail, gOrderCode);
            vXmlHttpOrderDetail.onreadystatechange = function() {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // B4: Xử lý hiển thị
                    displayOrderDetail(vXmlHttpOrderDetail);
                }
            }
        }
    }

    // function xử lý sự kiện click button Confirm
    function onBtnConfirmClick() {
        console.log("Button Confirm được click")
        console.log("Order ID: " + gOrderId);
        // B1: Thu thập dữ liệu
        let vOrderConfirm = {trangThai: "confirmed"};
        // B2: Validate dữ liệu
        // B3: Gọi API update thông tin đơn hàng bằng order ID
        let vXmlHttpUpdateOrder = new XMLHttpRequest();
        callApiUpdateOrder(vXmlHttpUpdateOrder, vOrderConfirm, gOrderId);
        vXmlHttpUpdateOrder.onreadystatechange = function() {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                // B4: Xử lý front-end
                alert("Đã Confirm đơn hàng thành công");
                onPageLoading();
            }
        }    
    }

    // function xử lý sự kiện click button Cancel
    function onBtnCancelClick() {
        console.log("Button Cancel được click")
        console.log("Order ID: " + gOrderId);
        // B1: Thu thập dữ liệu
        let vOrderCancel = {trangThai: "cancel"};
        // B2: Validate dữ liệu
        // B3: Gọi API update thông tin đơn hàng bằng order ID
        let vXmlHttpUpdateOrder = new XMLHttpRequest();
        callApiUpdateOrder(vXmlHttpUpdateOrder, vOrderCancel, gOrderId);
        vXmlHttpUpdateOrder.onreadystatechange = function() {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                // B4: Xử lý front-end
                alert("Đã Cancel đơn hàng thành công");
                onPageLoading();
            }
        }    
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function gọi API lấy thông tin đơn hàng bằng order code
    function callApiOrderDetail(paramXmlHttp, paramOrderCode) {
        paramXmlHttp.open("GET", gBASE_URL + "/" + paramOrderCode, true);
        paramXmlHttp.send();
    }

    // function gọi API update thông tin đơn hàng bằng order ID
    function callApiUpdateOrder(paramXmlHttp, paramOrderStatus, paramOrderId) {
        let vStringRequest = JSON.stringify(paramOrderStatus);
        paramXmlHttp.open("PUT", gBASE_URL + "/" + paramOrderId);
        paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlHttp.send(vStringRequest);
    }

    // function validate order code trên query
    function checkQueryString(paramOrderCode, paramOrderId) {
        if (paramOrderCode == "") {
            alert("Không có thông tin mã đơn hàng. Quay lại trang chủ");
            window.location.href = "orderList.html";
        }
        else if (paramOrderId == "") {
            alert("Không có thông tin ID đơn hàng. Quay lại trang chủ");
            window.location.href = "orderList.html";
        }
        return true;
    }

    // function hiển thị thông tin đơn hàng lên form
    function displayOrderDetail(paramXmlHttp) {
        // chuyển json string sang object
        let vOrderObject = JSON.parse(paramXmlHttp.responseText);
        // truy vấn phần tử các ô input
        let vOrderCodeInput = document.getElementById("input-ma-don");
        let vSizeInput = document.getElementById("input-kich-co");
        let vDuongKinhInput = document.getElementById("input-duong-kinh");
        let vSuonInput = document.getElementById("input-suon");
        let vSaladInput = document.getElementById("input-salad");
        let vLoaiPizzaInput = document.getElementById("input-loai-pizza");
        let vVoucherInput = document.getElementById("input-voucher");
        let vThanhTienInput = document.getElementById("input-thanh-tien");
        let vGiamGiaInput = document.getElementById("input-giam-gia");
        let vDrinkInput = document.getElementById("input-drink");
        let vNumberDrinkInput = document.getElementById("input-drink-number");
        let vFullnameInput = document.getElementById("input-fullname");
        let vEmailInput = document.getElementById("input-email");
        let vPhoneInput = document.getElementById("input-phone");
        let vAddressInput = document.getElementById("input-address");
        let vMessageInput = document.getElementById("input-message");
        let vStatusInput = document.getElementById("input-status");
        let vNgayTaoInput = document.getElementById("input-day-create");
        let vNgayCapNhatInput = document.getElementById("input-day-modify");
        // gán giá trị cho các ô input
        vOrderCodeInput.value = vOrderObject.orderCode;
        vSizeInput.value = vOrderObject.kichCo;
        vDuongKinhInput.value = vOrderObject.duongKinh;
        vSuonInput.value = vOrderObject.suon;
        vSaladInput.value = vOrderObject.salad;
        vLoaiPizzaInput.value = vOrderObject.loaiPizza;
        vVoucherInput.value = vOrderObject.idVourcher;
        vThanhTienInput.value = vOrderObject.thanhTien;
        vGiamGiaInput.value = vOrderObject.giamGia;
        vDrinkInput.value = vOrderObject.idLoaiNuocUong;
        vNumberDrinkInput.value = vOrderObject.soLuongNuoc;
        vFullnameInput.value = vOrderObject.hoTen;
        vEmailInput.value = vOrderObject.email;
        vPhoneInput.value = vOrderObject.soDienThoai;
        vAddressInput.value = vOrderObject.diaChi;
        vMessageInput.value = vOrderObject.loiNhan;
        vStatusInput.value = vOrderObject.trangThai;
        vNgayTaoInput.value = vOrderObject.ngayTao;
        vNgayCapNhatInput.value = vOrderObject.ngayCapNhat;
    }

</script>

</html>